<?php

class packageControllerPackage extends packageControllerTable {
    public static $attributes = ["url", "name", "repository", "description"];
    public static $table = "package_controller_packages";

    public function __construct($id=null) {
        parent::__construct($id);
    }

    // überschreibe packageControllerTable delete, weil auch module und templates mit gelöscht werden
    public function delete($template_path = "", $module_path = "") {
        if(!$template_path || !$module_path) return;
        parent::delete();

        // bekomme alle noch activen templates und module
        $templates = packageControllerTemplate::getList();
        $modules = packageControllerModule::getList();

        // lösche alle templates
        foreach($templates as $template) {
            if($template["package_id"] == $this->id) {
                $temp = new packageControllerTemplate($template["id"]);
                $temp->delete($template_path);
            }
        }

        // lösche alle module
        foreach($modules as $module) {
            if($module["package_id"] == $this->id) {
                $mod = new packageControllerModule($module["id"]);
                $mod->delete($module_path);
            }
        }
    }
}