<?php
// import requirements
$addon = rex_addon::get("package_controller");
require_once($addon->getPath() . "lib/scripts/requirements.php");



// installiert entweder module oder template
function installFolder($id = null, $path = "", $user = "", $typeName="") {
    if(!$id || !$path || !$user ||!$typeName) throw new Exception("could not install module, because parameters are missing.");
    
    // notwendige werte
    $date = date("Y-m-d H:i:s");

    if($typeName == "module") { 
        $table = "rex_module";
        $type = new packageControllerModule($id);
    } else if($typeName == "template") {
        $table = "rex_template";
        $type = new packageControllerTemplate($id);
    }

    // check requirements
    checkRequirements($type->getValue("requirements"));

    // name nach vorbild [id] name
    $name = "[" .$type->getValue("id"). "] " . $type->getValue("name");

    if(!is_dir($path . $name)) throw new Exception("could not find a folder");
    
    $path = $path . $name;

    // fürs template wird nur die template.txt benötigt
    // für module werden output.txt und input.txt benötigt
    if($typeName == "module") { 
        if(!is_file($path . "/output.txt")) throw new Exception("could not find output.txt");
        if(!is_file($path . "/input.txt")) throw new Exception("could not find input.txt");
        $output = rex_file::get($path . "/output.txt");
        $input = rex_file::get($path . "/input.txt");

    } else if($typeName == "template") {
        if(!is_file($path . "/template.txt")) throw new Exception("could not find template.txt");
        $template = rex_file::get($path . "/template.txt");
    }
   
  
    // insert into database
    $sql = rex_sql::factory();

    
    if($typeName == "module") { 
        $keys = "(name,output,input,createuser,updateuser,createdate,updatedate,attributes,revision)";
        $values = "(:name,:output,:input,:createuser,:updateuser,:createdate,:updatedate,:attributes,:revision)";
        $data = [
            ":name" => $type->getValue("name"),
            ":output"=> $output,
            ":input"=> $input,
            ":createuser"=> $user,
            ":updateuser"=> $user,
            ":createdate"=> $date,
            ":updatedate"=> $date,
            ":attributes"=> $type->getValue("attributes"),
            ":revision" => 0
        ];
    } else if($typeName == "template") {
        $keys = "(name,content,active,createuser,updateuser,createdate,updatedate,attributes,revision)";
        $values = "(:name,:content,:active,:createuser,:updateuser,:createdate,:updatedate,:attributes,:revision)";
        $data = [
            ":name" => $type->getValue("name"),
            ":content"=> $template,
            ":active"=> 1,
            ":createuser"=> $user,
            ":updateuser"=> $user,
            ":createdate"=> $date,
            ":updatedate"=> $date,
            ":attributes"=> $type->getValue("attributes"),
            ":revision" => 0
        ];
    }

    $query = "INSERT INTO " . $table . " " . $keys . " VALUES " . $values; 
    $sql->prepareQuery($query);
    $sql->execute($data);
}
